<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLContainersVertexBase-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__core.html">Core Classes</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core vertex class.  
 <a href="classTIGLContainersVertexBase.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersVertexBase_8hpp_source.html">tiglContainersVertexBase.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classTIGLContainersVertexBase.png" usemap="#TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map" alt=""/>
  <map id="TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map" name="TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map">
<area href="classTIGLApiVertex.html" title="Core vertex class for the TIGL Engine (with only output edge buffer). " alt="TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;" shape="rect" coords="0,56,508,80"/>
<area href="classTIGLContainersBiVertexBase.html" title="A vertex class with both input and output edges lists. " alt="TIGLContainersBiVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="518,56,1026,80"/>
<area href="classTIGLContainersBiVertex.html" title="Core vertex class with input and output edge buffers. " alt="TIGLContainersBiVertex&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="518,112,1026,136"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab12e0c19620ff872c8b793ff001f022b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ab12e0c19620ff872c8b793ff001f022b">TIGLContainersVertexBase</a> (IdType key)</td></tr>
<tr class="memdesc:ab12e0c19620ff872c8b793ff001f022b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#ab12e0c19620ff872c8b793ff001f022b">More...</a><br /></td></tr>
<tr class="separator:ab12e0c19620ff872c8b793ff001f022b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c2b931b7f439a72da6baaadbb6f753d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a0c2b931b7f439a72da6baaadbb6f753d">TIGLContainersVertexBase</a> (IdType key, DataType data, AlgDataType alg)</td></tr>
<tr class="memdesc:a0c2b931b7f439a72da6baaadbb6f753d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded constructor.  <a href="#a0c2b931b7f439a72da6baaadbb6f753d">More...</a><br /></td></tr>
<tr class="separator:a0c2b931b7f439a72da6baaadbb6f753d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3887a721638627b063306724ad8cf22b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3887a721638627b063306724ad8cf22b"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3887a721638627b063306724ad8cf22b">TIGLContainersVertexBase</a> ()</td></tr>
<tr class="memdesc:a3887a721638627b063306724ad8cf22b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded empty constructor. <br /></td></tr>
<tr class="separator:a3887a721638627b063306724ad8cf22b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a260b170afbb1f183b7d6247a148fea83"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a260b170afbb1f183b7d6247a148fea83"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a260b170afbb1f183b7d6247a148fea83">operator&lt;</a> (const <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:a260b170afbb1f183b7d6247a148fea83"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for list ordering. <br /></td></tr>
<tr class="separator:a260b170afbb1f183b7d6247a148fea83"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac1f818aadbfdd77acf6eb5974339b582"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac1f818aadbfdd77acf6eb5974339b582"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ac1f818aadbfdd77acf6eb5974339b582">operator==</a> (const <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:ac1f818aadbfdd77acf6eb5974339b582"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded equal operator for list ordering. <br /></td></tr>
<tr class="separator:ac1f818aadbfdd77acf6eb5974339b582"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cc87d2b4157b298460486dab71dfb44"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">addEdge</a> (EdgeType &amp;x)</td></tr>
<tr class="memdesc:a7cc87d2b4157b298460486dab71dfb44"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds output edge.  <a href="#a7cc87d2b4157b298460486dab71dfb44">More...</a><br /></td></tr>
<tr class="separator:a7cc87d2b4157b298460486dab71dfb44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d6b5c292809922673ceb6fdb188b6b3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a2d6b5c292809922673ceb6fdb188b6b3">addEdge</a> (ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:a2d6b5c292809922673ceb6fdb188b6b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds output edge (overloaded function)  <a href="#a2d6b5c292809922673ceb6fdb188b6b3">More...</a><br /></td></tr>
<tr class="separator:a2d6b5c292809922673ceb6fdb188b6b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9dc66486575edee5b2901b6fa01b370"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ae9dc66486575edee5b2901b6fa01b370">addEdge</a> (OUT_EDGE_BUF &amp;x)</td></tr>
<tr class="memdesc:ae9dc66486575edee5b2901b6fa01b370"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds multiple ouput edges.  <a href="#ae9dc66486575edee5b2901b6fa01b370">More...</a><br /></td></tr>
<tr class="separator:ae9dc66486575edee5b2901b6fa01b370"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a355bc674650678249bd53adc12f1cb4d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a355bc674650678249bd53adc12f1cb4d">removeEdge</a> (IdType &amp;target)</td></tr>
<tr class="memdesc:a355bc674650678249bd53adc12f1cb4d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes an output edge identified by target node.  <a href="#a355bc674650678249bd53adc12f1cb4d">More...</a><br /></td></tr>
<tr class="separator:a355bc674650678249bd53adc12f1cb4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae54bd25069156c7ff89a9907f2167b24"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae54bd25069156c7ff89a9907f2167b24"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ae54bd25069156c7ff89a9907f2167b24">clearEdges</a> ()</td></tr>
<tr class="memdesc:ae54bd25069156c7ff89a9907f2167b24"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears all output edges. <br /></td></tr>
<tr class="separator:ae54bd25069156c7ff89a9907f2167b24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8aa2da8ab2f06ff33fb499ee42b228ce"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8aa2da8ab2f06ff33fb499ee42b228ce"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">getNumOutEdges</a> ()</td></tr>
<tr class="memdesc:a8aa2da8ab2f06ff33fb499ee42b228ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of output edges. <br /></td></tr>
<tr class="separator:a8aa2da8ab2f06ff33fb499ee42b228ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77">getNumDifferentNbr</a> ()</td></tr>
<tr class="memdesc:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of neigbors excluding self (i.e., ignoring self cycles) <br /></td></tr>
<tr class="separator:a1fc8f9e57e5b9bfeaf5a33fe5f4d3d77"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd0b2f0822224ebb4ee9b2d9b6ae7ba0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">getChildren</a> (vector&lt; IdType &gt; &amp;vectChildren)</td></tr>
<tr class="memdesc:afd0b2f0822224ebb4ee9b2d9b6ae7ba0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex id of all children.  <a href="#afd0b2f0822224ebb4ee9b2d9b6ae7ba0">More...</a><br /></td></tr>
<tr class="separator:afd0b2f0822224ebb4ee9b2d9b6ae7ba0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b9a5ee6ceed8269cfde06116fa4fb30"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a6b9a5ee6ceed8269cfde06116fa4fb30">isConnected</a> (IdType node)</td></tr>
<tr class="memdesc:a6b9a5ee6ceed8269cfde06116fa4fb30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if a given node is connected to the current node.  <a href="#a6b9a5ee6ceed8269cfde06116fa4fb30">More...</a><br /></td></tr>
<tr class="separator:a6b9a5ee6ceed8269cfde06116fa4fb30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a776920aff39617337c8c0d11100fa948"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a776920aff39617337c8c0d11100fa948"></a>
DataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">get_value</a> ()</td></tr>
<tr class="memdesc:a776920aff39617337c8c0d11100fa948"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex data field. <br /></td></tr>
<tr class="separator:a776920aff39617337c8c0d11100fa948"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a782c440fc6c8ae87291f142239260091"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a782c440fc6c8ae87291f142239260091"></a>
AlgDataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">getAlgData</a> ()</td></tr>
<tr class="memdesc:a782c440fc6c8ae87291f142239260091"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the algorithm data. <br /></td></tr>
<tr class="separator:a782c440fc6c8ae87291f142239260091"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c2f4752f5f1df26b608ddc6400777aa"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5c2f4752f5f1df26b608ddc6400777aa"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">getId</a> ()</td></tr>
<tr class="memdesc:a5c2f4752f5f1df26b608ddc6400777aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the vertex id. <br /></td></tr>
<tr class="separator:a5c2f4752f5f1df26b608ddc6400777aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a077ed089a01250a2d15fc5acc7e3aaf6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a077ed089a01250a2d15fc5acc7e3aaf6"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">getBeginOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:a077ed089a01250a2d15fc5acc7e3aaf6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the start of the outEdges buffer. <br /></td></tr>
<tr class="separator:a077ed089a01250a2d15fc5acc7e3aaf6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3af614e7143fb092f6a3115514de319b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3af614e7143fb092f6a3115514de319b"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">getEndOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:a3af614e7143fb092f6a3115514de319b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the last edge of the outEdges buffer. <br /></td></tr>
<tr class="separator:a3af614e7143fb092f6a3115514de319b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb1a96d0d3ccc33e97c1b84af0a045d7"><td class="memItemLeft" align="right" valign="top">OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afb1a96d0d3ccc33e97c1b84af0a045d7">get_edge</a> (ID_TYPE target)</td></tr>
<tr class="memdesc:afb1a96d0d3ccc33e97c1b84af0a045d7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an iterator to the output edge with a given target.  <a href="#afb1a96d0d3ccc33e97c1b84af0a045d7">More...</a><br /></td></tr>
<tr class="separator:afb1a96d0d3ccc33e97c1b84af0a045d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af0521f19891d34cc1dfba07ec5bd83cd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">isBiVertex</a> ()</td></tr>
<tr class="memdesc:af0521f19891d34cc1dfba07ec5bd83cd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if the vertex type is <a class="el" href="classTIGLContainersBiVertex.html" title="Core vertex class with input and output edge buffers. ">TIGLContainersBiVertex</a>.  <a href="#af0521f19891d34cc1dfba07ec5bd83cd">More...</a><br /></td></tr>
<tr class="separator:af0521f19891d34cc1dfba07ec5bd83cd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ace8a3901abb1f925cd442ff24200b45f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ace8a3901abb1f925cd442ff24200b45f"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ace8a3901abb1f925cd442ff24200b45f">compute</a> (void *pIn=0, void *pOut=0)</td></tr>
<tr class="memdesc:ace8a3901abb1f925cd442ff24200b45f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core compute function: trivial realization in the core class. This function is overriden by the algorithm class. <br /></td></tr>
<tr class="separator:ace8a3901abb1f925cd442ff24200b45f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53510bd15bbce08013705a779d3b191a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a53510bd15bbce08013705a779d3b191a"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a53510bd15bbce08013705a779d3b191a">init</a> ()</td></tr>
<tr class="memdesc:a53510bd15bbce08013705a779d3b191a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core init function: trivial realization in the core class. This function is overriden by the algorithm class. <br /></td></tr>
<tr class="separator:a53510bd15bbce08013705a779d3b191a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcd5a44e577f8d3f69b6fb0b5f4fc2ec"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afcd5a44e577f8d3f69b6fb0b5f4fc2ec"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#afcd5a44e577f8d3f69b6fb0b5f4fc2ec">getEdgesSize</a> ()</td></tr>
<tr class="memdesc:afcd5a44e577f8d3f69b6fb0b5f4fc2ec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns memory usage for edges. <br /></td></tr>
<tr class="separator:afcd5a44e577f8d3f69b6fb0b5f4fc2ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a3f6edf01d8830e0b5b8ad74549eeb085"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3f6edf01d8830e0b5b8ad74549eeb085"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a3f6edf01d8830e0b5b8ad74549eeb085">id</a></td></tr>
<tr class="memdesc:a3f6edf01d8830e0b5b8ad74549eeb085"><td class="mdescLeft">&#160;</td><td class="mdescRight">unique vertex ID <br /></td></tr>
<tr class="separator:a3f6edf01d8830e0b5b8ad74549eeb085"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a42054ed48c73a733e99f3ef80698e50b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a42054ed48c73a733e99f3ef80698e50b"></a>
DataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a42054ed48c73a733e99f3ef80698e50b">vertexData</a></td></tr>
<tr class="memdesc:a42054ed48c73a733e99f3ef80698e50b"><td class="mdescLeft">&#160;</td><td class="mdescRight">associated generic data <br /></td></tr>
<tr class="separator:a42054ed48c73a733e99f3ef80698e50b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac36b610433331bb36b1c05a1fa942418"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac36b610433331bb36b1c05a1fa942418"></a>
AlgDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#ac36b610433331bb36b1c05a1fa942418">algData</a></td></tr>
<tr class="memdesc:ac36b610433331bb36b1c05a1fa942418"><td class="mdescLeft">&#160;</td><td class="mdescRight">Algorithm-specific data. <br /></td></tr>
<tr class="separator:ac36b610433331bb36b1c05a1fa942418"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e0e018b11f1fbe310789c332efed1b9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8e0e018b11f1fbe310789c332efed1b9"></a>
OUT_EDGE_BUF&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersVertexBase.html#a8e0e018b11f1fbe310789c332efed1b9">outEdges</a></td></tr>
<tr class="memdesc:a8e0e018b11f1fbe310789c332efed1b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">output edge buffer <br /></td></tr>
<tr class="separator:a8e0e018b11f1fbe310789c332efed1b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt;<br />
class TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;</h3>

<p>Core vertex class. </p>
<p>It contains all the vertex data and defines all vertex mutations It is a template class that is parameterized by the following parameters </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DataType</td><td>the type of the data field in the vertex </td></tr>
    <tr><td class="paramname">AlgDataType</td><td>the type of algorithm data filed in the vertex </td></tr>
    <tr><td class="paramname">EdgeType</td><td>the edge type </td></tr>
    <tr><td class="paramname">IdType</td><td>the data type of the ID field of each vertex </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab12e0c19620ff872c8b793ff001f022b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::<a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>the vertex ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0c2b931b7f439a72da6baaadbb6f753d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::<a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DataType&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">AlgDataType&#160;</td>
          <td class="paramname"><em>alg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Overloaded constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>the vertex ID </td></tr>
    <tr><td class="paramname">data</td><td>initial value of vertexData field </td></tr>
    <tr><td class="paramname">alg</td><td>initial value of algData field </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a7cc87d2b4157b298460486dab71dfb44"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">EdgeType &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds output edge. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the edge object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2d6b5c292809922673ceb6fdb188b6b3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds output edge (overloaded function) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the other side of the edge </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae9dc66486575edee5b2901b6fa01b370"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">OUT_EDGE_BUF &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds multiple ouput edges. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>a buffer of the output edges </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afb1a96d0d3ccc33e97c1b84af0a045d7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OUT_EDGE_ITERATOR <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::get_edge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns an iterator to the output edge with a given target. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the ID of the other side of the edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>iterator to the output edge if the edge exists, and end of buffer if the edge does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="afd0b2f0822224ebb4ee9b2d9b6ae7ba0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::getChildren </td>
          <td>(</td>
          <td class="paramtype">vector&lt; IdType &gt; &amp;&#160;</td>
          <td class="paramname"><em>vectChildren</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the vertex id of all children. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vectChildren</td><td>the output vector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af0521f19891d34cc1dfba07ec5bd83cd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::isBiVertex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if the vertex type is <a class="el" href="classTIGLContainersBiVertex.html" title="Core vertex class with input and output edge buffers. ">TIGLContainersBiVertex</a>. </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">false</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6b9a5ee6ceed8269cfde06116fa4fb30"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::isConnected </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>node</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Checks if a given node is connected to the current node. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">node</td><td>ID of the other node </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if connected, false if not connected </dd></dl>

</div>
</div>
<a class="anchor" id="a355bc674650678249bd53adc12f1cb4d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::removeEdge </td>
          <td>(</td>
          <td class="paramtype">IdType &amp;&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Removes an output edge identified by target node. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the other side of the edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge does not exit </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="tiglContainersVertexBase_8hpp_source.html">tiglContainersVertexBase.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:59 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
